<template>
  <div
    class="loader"
    v-if="visible">
    <div class="loader_inner">
      <!--      <div class="loader-header">
              <div
                class="loader-close"
                @click="close">
                <i class="i-icon-close"></i>
              </div>
            </div>-->
      <div class="loader-body">
        <ProgressCircle
          type="circle"
          :percentage="loading"
          strokeLinecap="butt"
          color="#01b9c3"
          status="success">
          <slot></slot>
        </ProgressCircle>
      </div>
    </div>
  </div>
</template>

<script>
  import ProgressCircle from '~/components/UI/ProgressCircle';

  export default {
    name: "Loader",
    props: {
      loadFunc: {
        type: Function,
        default: () => true
      },
      timeToLoad: {
        type: Number,
        default: 3000
      },
    },
    data() {
      return {
        visible: false,
        loaded: false,
        loading: 0,
        maxLoading: 90,
        interval: null
      }
    },
    components: {
      ProgressCircle
    },
    methods: {
      show() {
        this.visible = true;
        this.start();
      },
      close() {
        this.visible = false;
      },
      start() {
        this.loading = 0;
        const step = this.maxLoading / this.timeToLoad;
        const timestep = 100;
        this.interval = setInterval(_ => {
          if (this.loadFunc()) {
            this.loading = 100;
            clearInterval(this.interval);
            setTimeout(_ => {
              this.close();
            }, 800);
          }
          if (this.loading < this.maxLoading) {
            this.loading += parseInt(timestep * step);
          }
        }, timestep);
      }
    }
  }
</script>
